function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import { ARENA_CURTAIN_INIT_SAGA, ARENA_CURTAIN_CLEAR_REDUX } from "../../core/actionTypes";
import { createCurtainReducer } from "../../core/reducers";
import { curtainAddReducer, calcCurtainReducerDict } from "../../utils";
import { arenaCurtainConnect } from "../SceneBundle";

var ArenaScene = function (_Component) {
  _inherits(ArenaScene, _Component);

  function ArenaScene() {
    _classCallCheck(this, ArenaScene);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  ArenaScene.prototype.componentWillMount = function componentWillMount() {
    var _this2 = this;

    var reducerKey = curtainAddReducer(this.context.store, this.props.reducerKey, createCurtainReducer);
    var _props = this.props,
        asyncSceneBundle = _props.asyncSceneBundle,
        sceneBundle = _props.sceneBundle,
        sceneProps = _props.sceneProps,
        isNotifyOn = _props.isNotifyOn,
        notifyData = _props.notifyData;

    var arenaReducerDict = calcCurtainReducerDict(this.context.arenaReducerDict, reducerKey, this.props.vReducerKey);
    var wrappedSceneBundle = arenaCurtainConnect(arenaReducerDict);
    var sceneBundleElement = React.createElement(wrappedSceneBundle, {
      asyncSceneBundle: asyncSceneBundle,
      sceneBundle: sceneBundle,
      sceneProps: sceneProps,
      isNotifyOn: isNotifyOn,
      notifyData: notifyData
    });
    this.setState({
      arenaReducerDict: arenaReducerDict,
      wrappedSceneBundle: wrappedSceneBundle,
      sceneBundleElement: sceneBundleElement,
      sagaTaskPromise: new Promise(function (resolve) {
        return _this2.context.store.dispatch({
          type: ARENA_CURTAIN_INIT_SAGA,
          reducerKey: reducerKey,
          setSagaTask: resolve
        });
      })
    });
  };

  ArenaScene.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps, nextContext) {
    var refreshFlag = false;
    var state = Object.assign({}, this.state);
    var reducerKey = nextProps.reducerKey,
        vReducerKey = nextProps.vReducerKey,
        asyncSceneBundle = nextProps.asyncSceneBundle,
        sceneBundle = nextProps.sceneBundle,
        sceneProps = nextProps.sceneProps,
        isNotifyOn = nextProps.isNotifyOn,
        notifyData = nextProps.notifyData;

    var newReducerKey = state.arenaReducerDict._arenaCurtain.reducerKey;
    if (reducerKey != null && reducerKey !== state.arenaReducerDict._arenaCurtain.reducerKey) {
      refreshFlag = true;
      nextContext.store.dispatch({
        type: ARENA_CURTAIN_CLEAR_REDUX,
        reducerKey: state.arenaReducerDict._arenaCurtain.reducerKey,
        sagaTaskPromise: state.sagaTaskPromise
      });
      newReducerKey = curtainAddReducer(nextContext.store, reducerKey, createCurtainReducer);
      state.sagaTaskPromise = new Promise(function (resolve) {
        return nextContext.store.dispatch({
          type: ARENA_CURTAIN_INIT_SAGA,
          reducerKey: newReducerKey,
          setSagaTask: resolve
        });
      });
    }
    if (nextContext.arenaReducerDict !== this.context.arenaReducerDict || reducerKey !== this.props.reducerKey || vReducerKey !== this.props.vReducerKey || refreshFlag === true) {
      refreshFlag = true;
      state.arenaReducerDict = calcCurtainReducerDict(nextContext.arenaReducerDict, newReducerKey, nextProps.vReducerKey);
      state.wrappedSceneBundle = arenaCurtainConnect(state.arenaReducerDict);
    }
    if (asyncSceneBundle !== this.props.asyncSceneBundle || sceneBundle !== this.props.sceneBundle || sceneProps !== this.props.sceneBundle || notifyData !== this.props.notifyData || refreshFlag == true) {
      state.sceneBundleElement = React.createElement(state.wrappedSceneBundle, {
        asyncSceneBundle: asyncSceneBundle,
        sceneBundle: sceneBundle,
        sceneProps: sceneProps,
        isNotifyOn: isNotifyOn,
        notifyData: notifyData
      });
    }
    this.setState(state);
  };

  ArenaScene.prototype.componentWillUnmount = function componentWillUnmount() {
    this.context.store.dispatch({
      type: ARENA_CURTAIN_CLEAR_REDUX,
      reducerKey: this.state.arenaReducerDict._arenaCurtain.reducerKey,
      sagaTaskPromise: this.state.sagaTaskPromise
    });
  };

  ArenaScene.prototype.render = function render() {
    return this.state.sceneBundleElement;
  };

  return ArenaScene;
}(Component);

ArenaScene.contextTypes = {
  store: PropTypes.any,
  arenaReducerDict: PropTypes.object
};
ArenaScene.propTypes = {
  reducerKey: PropTypes.string,
  vReducerKey: PropTypes.string,
  sceneBundle: PropTypes.object,
  asyncSceneBundle: PropTypes.object,
  sceneProps: PropTypes.object,
  isNotifyOn: PropTypes.bool,
  notifyData: PropTypes.object
};
export default ArenaScene;