import { ARENA_CURTAIN_LOAD_SCENE, ARENA_CURTAIN_LOAD_ASYNCSCENE } from "../../core/actionTypes";
import { ARENA_SCENEBUNDLE_LOAD_START, ARENA_SCENEBUNDLE_PLAY_START, ARENA_SCENEBUNDLE_UNMOUNT_START } from "../../actionTypes";

function chooseBundle(sceneBundle, asyncSceneBundle) {
  return sceneBundle ? { sceneBundle: sceneBundle } : { asyncSceneBundle: asyncSceneBundle };
}

export function arenaLoadScene(parentArenaReducerDict, sceneBundle, asyncSceneBundle, notifyData, isInitial) {
  var bundleObj = chooseBundle(sceneBundle, asyncSceneBundle);
  if (bundleObj.sceneBundle) {
    return {
      type: ARENA_CURTAIN_LOAD_SCENE,
      parentArenaReducerDict: parentArenaReducerDict,
      sceneBundle: sceneBundle,
      isInitial: isInitial,
      notifyAction: {
        arenaReducerDict: parentArenaReducerDict,
        sceneBundle: sceneBundle,
        notifyData: notifyData,
        isInitial: isInitial
      }
    };
  } else {
    return {
      type: ARENA_CURTAIN_LOAD_ASYNCSCENE,
      parentArenaReducerDict: parentArenaReducerDict,
      asyncSceneBundle: asyncSceneBundle,
      isInitial: isInitial,
      notifyAction: {
        arenaReducerDict: parentArenaReducerDict,
        asyncSceneBundle: asyncSceneBundle,
        notifyData: notifyData,
        isInitial: isInitial
      }
    };
  }
}

export function sceneLoadStart(parentArenaReducerDict, sceneBundle, asyncSceneBundle, notifyData, isInitial) {
  return Object.assign({
    type: ARENA_SCENEBUNDLE_LOAD_START,
    arenaReducerDict: parentArenaReducerDict,
    notifyData: notifyData,
    isInitial: isInitial
  }, chooseBundle(sceneBundle, asyncSceneBundle));
}

export function sceneStartPlay(parentArenaReducerDict, sceneBundle, asyncSceneBundle, notifyData) {
  return Object.assign({
    type: ARENA_SCENEBUNDLE_PLAY_START,
    arenaReducerDict: parentArenaReducerDict,
    notifyData: notifyData
  }, chooseBundle(sceneBundle, asyncSceneBundle));
}

export function sceneStopPlay(parentArenaReducerDict, sceneBundle, asyncSceneBundle, notifyData) {
  return Object.assign({
    type: ARENA_SCENEBUNDLE_UNMOUNT_START,
    arenaReducerDict: parentArenaReducerDict,
    notifyData: notifyData
  }, chooseBundle(sceneBundle, asyncSceneBundle));
}