"use strict";

exports.__esModule = true;
exports.default = createCurtainReducer;

var _actionTypes = require("../actionTypes.js");

var _getCurtainInitState = require("./getCurtainInitState");

var _getCurtainInitState2 = _interopRequireDefault(_getCurtainInitState);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function curtainReducer(state, action, boundReducerKey) {
  switch (action.type) {
    case _actionTypes.ARENA_CURTAIN_SET_STATE:
      return Object.assign({}, state, action.state);
    case _actionTypes.ARENA_CURTAIN_REPLACE_STATE:
      return Object.assign({}, action.state);
    default:
      return state;
  }
}

function createCurtainReducer(boundReducerKey) {
  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : (0, _getCurtainInitState2.default)();
    var action = arguments[1];

    if (boundReducerKey === action._reducerKey) {
      state = curtainReducer(state, action, boundReducerKey);
    }
    return state;
  };
}