"use strict";

exports.__esModule = true;

var _effects = require("redux-saga/effects");

var _getArenaReducerDictEntry = require("./getArenaReducerDictEntry");

var _getArenaReducerDictEntry2 = _interopRequireDefault(_getArenaReducerDictEntry);

var _reduxSaga = require("redux-saga");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _marked = /*#__PURE__*/regeneratorRuntime.mark(_takeSceneAction),
    _marked2 = /*#__PURE__*/regeneratorRuntime.mark(_takeSceneActionMaybe);

function _takeSceneAction(pattern, key) {
  var action, entry;
  return regeneratorRuntime.wrap(function _takeSceneAction$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          if (!true) {
            _context.next = 11;
            break;
          }

          _context.next = 3;
          return (0, _effects.take)(pattern);

        case 3:
          action = _context.sent;
          _context.next = 6;
          return (0, _getArenaReducerDictEntry2.default)(key);

        case 6:
          entry = _context.sent;

          if (!(action._sceneReducerKey === entry.reducerKey)) {
            _context.next = 9;
            break;
          }

          return _context.abrupt("return", action);

        case 9:
          _context.next = 0;
          break;

        case 11:
        case "end":
          return _context.stop();
      }
    }
  }, _marked, this);
}

function _takeSceneActionMaybe(pattern, key) {
  var action, entry;
  return regeneratorRuntime.wrap(function _takeSceneActionMaybe$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          if (!true) {
            _context2.next = 11;
            break;
          }

          _context2.next = 3;
          return _effects.take.maybe(pattern);

        case 3:
          action = _context2.sent;
          _context2.next = 6;
          return (0, _getArenaReducerDictEntry2.default)(key);

        case 6:
          entry = _context2.sent;

          if (!(action._sceneReducerKey === entry.reducerKey || action.type === _reduxSaga.END.type)) {
            _context2.next = 9;
            break;
          }

          return _context2.abrupt("return", action);

        case 9:
          _context2.next = 0;
          break;

        case 11:
        case "end":
          return _context2.stop();
      }
    }
  }, _marked2, this);
}

var takeSceneAction = function takeSceneAction(pattern) {
  var key = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "_arenaScene";

  return (0, _effects.call)(_takeSceneAction, pattern, key);
};

takeSceneAction.maybe = function (pattern) {
  var key = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "_arenaScene";

  return (0, _effects.call)(_takeSceneActionMaybe, pattern, key);
};

exports.default = takeSceneAction;