"use strict";

exports.__esModule = true;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SceneBundle = function (_Component) {
  _inherits(SceneBundle, _Component);

  function SceneBundle() {
    _classCallCheck(this, SceneBundle);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  SceneBundle.prototype.getChildContext = function getChildContext() {
    return {
      arenaReducerDict: this.props.reduxInfo.arenaReducerDict
    };
  };

  SceneBundle.prototype.componentWillMount = function componentWillMount() {
    var _this2 = this;

    this.setState({
      isSceneBundleValid: false,
      initialPromoise: new Promise(function (resolve) {
        setImmediate(function () {
          _this2.loadScene(_this2.props, true);
          resolve(true);
        });
      })
    });
  };

  SceneBundle.prototype.componentWillUnmount = function componentWillUnmount() {
    if (this.props.isNotifyOn) {
      this.props.sceneStopPlay(this.props.parentArenaReducerDict, this.props.sceneBundle, this.props.asyncSceneBundle, this.props.notifyData);
    }
  };

  SceneBundle.prototype.checkAndStartPlay = function checkAndStartPlay(props, nextProps) {
    if (nextProps.PlayingScene != null && nextProps.PlayingScene !== props.PlayingScene) {
      this.setState({
        isSceneBundleValid: true
      }, function () {
        if (nextProps.isNotifyOn) {
          nextProps.sceneStartPlay(nextProps.parentArenaReducerDict, nextProps.sceneBundle, nextProps.asyncSceneBundle, nextProps.notifyData);
        }
      });
    }
  };

  SceneBundle.prototype.componentDidMount = function componentDidMount() {
    this.checkAndStartPlay({}, this.props);
  };

  SceneBundle.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var _this3 = this;

    var asyncSceneBundle = nextProps.asyncSceneBundle,
        sceneBundle = nextProps.sceneBundle;

    this.checkAndStartPlay(this.props, nextProps);
    if (asyncSceneBundle !== this.props.asyncSceneBundle || sceneBundle !== this.props.sceneBundle) {
      this.state.initialPromoise.then(function () {
        return _this3.loadScene(nextProps, false);
      });
    }
    if (nextProps.PlayingScene == null) {
      this.setState({
        isSceneBundleValid: false
      });
    }
  };

  SceneBundle.prototype.loadScene = function loadScene(props, isInitial) {
    if (props.isNotifyOn) {
      props.sceneLoadStart(props.parentArenaReducerDict, props.sceneBundle, props.asyncSceneBundle, props.notifyData, isInitial);
    }
    props.arenaLoadScene(props.parentArenaReducerDict, props.sceneBundle, props.asyncSceneBundle, props.notifyData, isInitial);
  };

  SceneBundle.prototype.render = function render() {
    var _props = this.props,
        PlayingScene = _props.PlayingScene,
        sceneProps = _props.sceneProps;

    if (this.state.isSceneBundleValid) {
      return _react2.default.createElement(PlayingScene, sceneProps);
    } else {
      return _react2.default.createElement("div", null);
    }
  };

  return SceneBundle;
}(_react.Component);

SceneBundle.propTypes = {
  asyncSceneBundle: _propTypes2.default.any,
  sceneBundle: _propTypes2.default.object,
  sceneProps: _propTypes2.default.object,
  isNotifyOn: _propTypes2.default.bool,
  notifyData: _propTypes2.default.object
};
SceneBundle.defaultProps = {
  isNotifyOn: false
};
SceneBundle.childContextTypes = {
  arenaReducerDict: _propTypes2.default.object
};
exports.default = SceneBundle;