"use strict";

exports.__esModule = true;
exports.arenaLoadScene = arenaLoadScene;
exports.sceneLoadStart = sceneLoadStart;
exports.sceneStartPlay = sceneStartPlay;
exports.sceneStopPlay = sceneStopPlay;

var _actionTypes = require("../../core/actionTypes");

var _actionTypes2 = require("../../actionTypes");

function chooseBundle(sceneBundle, asyncSceneBundle) {
  return sceneBundle ? { sceneBundle: sceneBundle } : { asyncSceneBundle: asyncSceneBundle };
}

function arenaLoadScene(parentArenaReducerDict, sceneBundle, asyncSceneBundle, notifyData, isInitial) {
  var bundleObj = chooseBundle(sceneBundle, asyncSceneBundle);
  if (bundleObj.sceneBundle) {
    return {
      type: _actionTypes.ARENA_CURTAIN_LOAD_SCENE,
      parentArenaReducerDict: parentArenaReducerDict,
      sceneBundle: sceneBundle,
      isInitial: isInitial,
      notifyAction: {
        arenaReducerDict: parentArenaReducerDict,
        sceneBundle: sceneBundle,
        notifyData: notifyData,
        isInitial: isInitial
      }
    };
  } else {
    return {
      type: _actionTypes.ARENA_CURTAIN_LOAD_ASYNCSCENE,
      parentArenaReducerDict: parentArenaReducerDict,
      asyncSceneBundle: asyncSceneBundle,
      isInitial: isInitial,
      notifyAction: {
        arenaReducerDict: parentArenaReducerDict,
        asyncSceneBundle: asyncSceneBundle,
        notifyData: notifyData,
        isInitial: isInitial
      }
    };
  }
}

function sceneLoadStart(parentArenaReducerDict, sceneBundle, asyncSceneBundle, notifyData, isInitial) {
  return Object.assign({
    type: _actionTypes2.ARENA_SCENEBUNDLE_LOAD_START,
    arenaReducerDict: parentArenaReducerDict,
    notifyData: notifyData,
    isInitial: isInitial
  }, chooseBundle(sceneBundle, asyncSceneBundle));
}

function sceneStartPlay(parentArenaReducerDict, sceneBundle, asyncSceneBundle, notifyData) {
  return Object.assign({
    type: _actionTypes2.ARENA_SCENEBUNDLE_PLAY_START,
    arenaReducerDict: parentArenaReducerDict,
    notifyData: notifyData
  }, chooseBundle(sceneBundle, asyncSceneBundle));
}

function sceneStopPlay(parentArenaReducerDict, sceneBundle, asyncSceneBundle, notifyData) {
  return Object.assign({
    type: _actionTypes2.ARENA_SCENEBUNDLE_UNMOUNT_START,
    arenaReducerDict: parentArenaReducerDict,
    notifyData: notifyData
  }, chooseBundle(sceneBundle, asyncSceneBundle));
}