"use strict";

exports.__esModule = true;
exports.sceneRmAndAddReducer = sceneRmAndAddReducer;

var _actionTypes = require("../core/actionTypes");

function sceneRmAndAddReducer(store, reducerKeyRemoved, reducerKeyAdded, reducerFactory, state) {
  var newReducerKey = store.removeAndAddReducer({
    reducerKeyRemoved: reducerKeyRemoved,
    reducerKeyAdded: reducerKeyAdded,
    reducer: reducerFactory(reducerKeyAdded),
    state: state
  });
  if (state) {
    store.dispatch({
      type: _actionTypes.ARENA_SCENE_REPLACE_STATE,
      _sceneReducerKey: newReducerKey,
      state: state
    });
  }
  return newReducerKey;
}